diff -rN -u old-trunk/NEWS new-trunk/NEWS
--- old-trunk/NEWS	2011-01-30 17:41:05.000000000 -0800
+++ new-trunk/NEWS	2011-01-30 17:41:11.000000000 -0800
@@ -1,12 +1,13 @@
 User visible changes in Tahoe-LAFS.  -*- outline; coding: utf-8 -*-
 
-* Release 1.8.2 (?)
+* Release 1.8.2 (2011-01-30)
 
 ** Compatibility and Dependencies
 
- - Tahoe is now compatible with Twisted-10.2 (released last month). The
-   previous Tahoe-1.8.1 release failed to run against Twisted-10.2,
-   raising an AttributeError on StreamServerEndpointService (#1286)
+ - Tahoe is now compatible with Twisted-10.2 (released last month), as well
+   as all earlier versions back to Twisted-2.4.0 . The previous Tahoe-1.8.1
+   release failed to run against Twisted-10.2, raising an AttributeError on
+   StreamServerEndpointService (#1286)
  - Tahoe now depends upon the "mock" testing library, and the foolscap
    dependency was raised to 0.6.1 . It no longer requires pywin32 (which
    was used only on windows). Future developers should note that
@@ -22,6 +23,8 @@
  - tahoe processes should appear in top and ps as "tahoe", not "python",
    on some unix platforms. (#174)
  - "tahoe debug trial" can be used to run the test suite (#1296)
+ - the SFTP frontend now reports unknown sizes as "0" instead of "?",
+   to improve compatibility with clients like FileZilla (#1337)
 
 
 * Release 1.8.1 (2010-10-28)
diff -rN -u old-trunk/docs/known_issues.rst new-trunk/docs/known_issues.rst
--- old-trunk/docs/known_issues.rst	2011-01-30 17:41:10.000000000 -0800
+++ new-trunk/docs/known_issues.rst	2011-01-30 17:41:15.000000000 -0800
@@ -24,7 +24,7 @@
 <historical/historical_known_issues.txt>`_.
 
 
-Issues in Tahoe-LAFS v1.8.1, released 2010-11-28
+Issues in Tahoe-LAFS v1.8.2, released 2011-01-30
 ================================================
 
 Potential unauthorized access by JavaScript in unrelated files
diff -rN -u old-trunk/docs/quickstart.html new-trunk/docs/quickstart.html
--- old-trunk/docs/quickstart.html	2011-01-30 17:41:10.000000000 -0800
+++ new-trunk/docs/quickstart.html	2011-01-30 17:41:15.000000000 -0800
@@ -49,9 +49,9 @@
 
     <h2>Get Tahoe-LAFS</h2>
 
-    <p>Download the latest stable release, v1.8.1:</p>
+    <p>Download the latest stable release, v1.8.2:</p>
     <pre><a
-    href="http://tahoe-lafs.org/source/tahoe-lafs/releases/allmydata-tahoe-1.8.1.zip">http://tahoe-lafs.org/source/tahoe-lafs/releases/allmydata-tahoe-1.8.1.zip</a></pre>
+    href="http://tahoe-lafs.org/source/tahoe-lafs/releases/allmydata-tahoe-1.8.2.zip">http://tahoe-lafs.org/source/tahoe-lafs/releases/allmydata-tahoe-1.8.2.zip</a></pre>
 
     <h2>Set Up Tahoe-LAFS</h2>
 
diff -rN -u old-trunk/relnotes.txt new-trunk/relnotes.txt
--- old-trunk/relnotes.txt	2011-01-30 17:41:05.000000000 -0800
+++ new-trunk/relnotes.txt	2011-01-30 17:41:11.000000000 -0800
@@ -1,7 +1,7 @@
-﻿ANNOUNCING Tahoe, the Least-Authority File System, v1.8.1
+﻿ANNOUNCING Tahoe, the Least-Authority File System, v1.8.2
 
 The Tahoe-LAFS team is pleased to announce the immediate
-availability of version 1.8.1 of Tahoe-LAFS, an extremely
+availability of version 1.8.2 of Tahoe-LAFS, an extremely
 reliable distributed storage system. Get it here:
 
 http://tahoe-lafs.org/source/tahoe/trunk/docs/quickstart.html
@@ -14,13 +14,12 @@
 
 http://tahoe-lafs.org/source/tahoe/trunk/docs/about.html
 
-The previous stable release of Tahoe-LAFS was v1.8.0, which was
-released September 23, 2010 [1].
+The previous stable release of Tahoe-LAFS was v1.8.1, which was
+released October 28, 2010 [1].
 
-v1.8.1 is a stable bugfix release correcting a number of minor
-issues. It also includes a modest performance improvement in
-downloading, and a fix for a security issue involving HTTP
-proxies. See the NEWS file [2] for details.
+v1.8.2 is a stable bugfix release, adding compatibility with
+the recently-released Twisted-10.2, and correcting a number of
+minor issues. See the NEWS file [2] for details.
 
 
 WHAT IS IT GOOD FOR?
@@ -62,7 +61,7 @@
 clients of all versions back to v1.0 and clients from this
 release can use servers of all versions back to v1.0.
 
-This is the twelfth release in the version 1 series. This
+This is the thirteenth release in the version 1 series. This
 series of Tahoe-LAFS will be actively supported and maintained
 for the forseeable future, and future versions of Tahoe-LAFS
 will retain the ability to read and write files compatible
@@ -133,20 +132,20 @@
 
 ACKNOWLEDGEMENTS
 
-This is the sixth release of Tahoe-LAFS to be created solely
+This is the seventh release of Tahoe-LAFS to be created solely
 as a labor of love by volunteers. Thank you very much to the
 team of "hackers in the public interest" who make Tahoe-LAFS
 possible.
 
-David-Sarah Hopwood and Zooko Wilcox-O'Hearn
+Brian Warner
 on behalf of the Tahoe-LAFS team
 
-November 28, 2010
-Rainhill, Merseyside, UK and Boulder, Colorado, USA
+January 30, 2011
+San Francisco, California, USA
 
 
-[1] http://tahoe-lafs.org/trac/tahoe/browser/relnotes.txt?rev=4747
-[2] http://tahoe-lafs.org/trac/tahoe/browser/NEWS?rev=4854
+[1] http://tahoe-lafs.org/trac/tahoe/browser/relnotes.txt?rev=4865
+[2] http://tahoe-lafs.org/trac/tahoe/browser/NEWS?rev=5000
 [3] http://tahoe-lafs.org/trac/tahoe/wiki/RelatedProjects
 [4] http://tahoe-lafs.org/trac/tahoe/browser/docs/known_issues.rst
 [5] http://tahoe-lafs.org/trac/tahoe/browser/COPYING.GPL
@@ -154,6 +153,6 @@
 [7] http://tahoe-lafs.org/source/tahoe/trunk/docs/quickstart.html
 [8] http://tahoe-lafs.org/cgi-bin/mailman/listinfo/tahoe-dev
 [9] http://tahoe-lafs.org/trac/tahoe/roadmap
-[10] http://tahoe-lafs.org/trac/tahoe/browser/CREDITS?rev=4797
+[10] http://tahoe-lafs.org/trac/tahoe/browser/CREDITS?rev=5000
 [11] http://tahoe-lafs.org/trac/tahoe/wiki/Dev
 [12] http://tahoe-lafs.org/hacktahoelafs/